# Colour experiments

This repository implements a couple of colour perception experiments
intended for our submission to the NIPS conference.
One experiment is an MCMCP experiment, the other is a GSP experiment.
Both can be launched from the same `experiment.py` file by tweaking the configuration parameters.

## Configuring the experiment

The main thing to do is change the `CONFIG["mode"]` parameter to either
`"mcmcp"` or `"gsp"`, depending on whether you want to run an MCMCP experiment or a GSP experiment.
Also, don't forget to set `us_only = true` and `initial_recruitment_size = 11`.
Then you can go ahead and deploy the experiment with `dallinger deploy`.

**Careful:** Dallinger fails if you deploy two experiments at the same time with the same name.
Therefore, if you're deploying both MCMCP and GSP, you should go to `config.txt`
and change the title parameter so that each experiment has a unique title. For example:

* title = Colour perception experiment ($9.00/hour bonus!) (MCMCP)
* title = Colour perception experiment ($9.00/hour bonus!) (GSP)
